#import <React/RCTLog.h>
#include <math.h>



//#import "Types.h"
#import "jibeStreamMapModule.h"
#import "JibestreamConverter.h"
#import "EventEmitter.h"





#import <JMapCoreKit.h>
#import <JMapControllerKit.h>
#import <JMapNavigationKit.h>
#import <extend.h>

//#import "Headers/JMapNavigationKit.h"
//#import "Headers/JMapCoreKit.h"
//#import "Headers/JMapControllerKit.h"
//#import "Headers/extend.h"




@interface jibeStreamMapModule() <JMapJCoreDelegate, OnExtendDelegate, JMapDelegate>

@property (nonatomic) JMap *jMap;
@property (nonatomic) JMapJCore *jCore;
@property (nonatomic) JMapController *controller;
@property (strong, nonatomic) JMapCanvas *canvas;
@property (nonatomic) JMapNavigation *navKit;

// Arrow icon object
//@property (nonatomic, strong) JMapMovingObject * arrow;
//@property (nonatomic) JMapUI *mapUIKit;

@property (strong, nonatomic) Extend * extend;

@end

@implementation jibeStreamMapModule

RCTPromiseResolveBlock initializeResolveCallbackId;
RCTPromiseRejectBlock initializeRejectCallbackId;

CTPEventEmitter *eventEmitter;
JMapOptions *options;

NSMutableDictionary * generatedPaths;

bool followBlueDot = false;
bool followBlueDotHeading = false;
NSNumber * followBlueDotInterval = 0;
long long lastFollowBlueDot = 0;
UIImage * arrowIcon;

// To export a module named DateModule
RCT_EXPORT_MODULE(jibestreamMap);

- (UIView *)view
{
    generatedPaths = [NSMutableDictionary dictionary];
    
    self.canvas = [[JMapCanvas alloc] initWithFrame:CGRectMake(0, 0, [UIApplication sharedApplication].delegate.window.frame.size.width, [UIApplication sharedApplication].delegate.window.frame.size.height)];
    
      eventEmitter = [CTPEventEmitter allocWithZone: nil];
    self.extend = [Extend sharedExtendWithKey:@"Aw8AAAAAAAAAAAAAB_EQgAAAAAAH526AAAABjcz8gTOSGNRz5n_zeh6fqGzVpqMQTcWa6rvA2C_s7-PzmEzERIBb0xNK1qFWBg9q5GgyMPjrnopRBhDlMaQLhZ1GzhhM72FXlGLxx8sEa4cS-9tLRLH5zbaTNNDeUgrgtKu23mY4UieyiVio-_4jOec-siieHeH760m9hfxbMVA" url:@"https://v2.tendegrees.net" delegate:self];
    [self.extend setVicinityEnabled:true];
    
    
//    NSURL *url = [NSURL URLWithString:[imagePath stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]]];
//    UIImage *image = [[UIImage alloc] initWithData:[NSData dataWithContentsOfURL:url]];
    arrowIcon = [UIImage imageNamed:@"path-arrow"];
    
    return self.canvas;
}

RCT_REMAP_METHOD(loadMap,
                 withDestroyResolver:(RCTPromiseResolveBlock)resolveDestroy
                 withDestroyRejecter:(RCTPromiseRejectBlock)rejectDestroy)
{
    initializeResolveCallbackId = resolveDestroy;
    initializeRejectCallbackId = rejectDestroy;
    [self loadMap];
    
}

RCT_EXPORT_METHOD(start:(NSString *) key url:(NSString *) url)
{
    NSLog(@"IOS Start Method Called");
};

RCT_EXPORT_METHOD(create:(nonnull NSNumber *) reactTag)
{
    NSLog(@"Create - Create function is not required for IOS.");
};

RCT_EXPORT_METHOD(center:(nonnull NSNumber *) reactTag 
                    rotation:(nonnull NSNumber *) rotation
                    zoom: (nonnull NSNumber * ) zoom
                    animationDuration:(nonnull NSNumber *) animationDuration)
{
    dispatch_async(dispatch_get_main_queue(), ^{
//        NSValue *centerPoint = [NSValue valueWithCGPoint:CGPointMake(self.controller.userLocation.center.x, self.controller.userLocation.center.y)];
        
        JMapTransform *transform = [[JMapTransform alloc] initWithX:@(self.controller.userLocation.center.x) y:@(self.controller.userLocation.center.y) scale:@5 rotation:rotation atCenter:nil duration:(animationDuration.floatValue / 1000.0)];
        [self.controller setMapTransform:transform];
    });
};

RCT_EXPORT_METHOD(setMapVenue:(nonnull NSNumber *) reactTag
                  credentials:(NSDictionary *) credentials)
                //   compass:(NSDictionary *) compass
                //   floorSelector:(NSDictionary *) floorSelector
                //   zoomButtons:(NSDictionary *) zoomButtons
                //   search:(NSDictionary *) search)
{

    NSLog(@"Received SetMapVenue");
    printf("%i",([[credentials objectForKey:@"venueId"] intValue]));
    options = [[JMapOptions alloc] init];
    options.venueId = [[credentials objectForKey:@"venueId"] intValue];
    options.host = [credentials objectForKey:@"host"];
    options.customerId = [[credentials objectForKey:@"customerId"] intValue];
    options.clientId = [credentials objectForKey:@"clientId"];
    options.clientSecret = [credentials objectForKey:@"clientSecret"];
    options.stage = self.canvas;
    options.clearCacheData = true;
    options.autoReloadCache = [NSNumber numberWithBool:true];

    [self loadMap];
};

RCT_EXPORT_METHOD(centerMapOnPoint:(nonnull NSNumber *) reactTag
                    point:(NSArray *) point)
{
    NSLog(@"centerMapOnPoint - Not implemented yet");
};

RCT_EXPORT_METHOD(setFollowBlueDot:(nonnull NSNumber *)
                  reactTag enabled:(BOOL) enabled
                    rotate:(BOOL *) rotate
                    interval:(nonnull NSNumber *) interval)
{
    followBlueDot = enabled;
    followBlueDotHeading = rotate;
    followBlueDotInterval = interval;
    
    if(followBlueDot){
        [self centerMapOnPosition:@(self.controller.userLocation.position.x) y:@(self.controller.userLocation.position.y) zoom:@5 orientation:@(self.controller.userLocation.orientation) animationDuration:@1500];
    }
};


RCT_EXPORT_METHOD(setUserPosition:(nonnull NSNumber *) reactTag
    x:(nonnull NSNumber *) x
    y:(nonnull NSNumber *) y
    heading:(nonnull NSNumber *) heading
    confidence:(nonnull NSNumber *) confidence
    format:(NSString *) format)
{
//    dispatch_async(dispatch_get_main_queue(), ^{/Users/tony/Documents/ITS4US/ctp-odp/ios/JibestreamConverter.m
        CGPoint convertPoint = CGPointMake(x.floatValue, y.floatValue);
        if(![format isEqualToString:@"xy"]){
            convertPoint = [JMapUtils convertPoint:convertPoint fromProjection:@"EPSG:4326" toProjection:@"jmap:local" inVenue:self.controller.activeVenue];
        }

        float angle = [self getAngleBetweenPoints:self.controller.userLocation.position endPoint:convertPoint];
        float distance = [self getDistanceBetweenPoints:self.controller.userLocation.position endPoint:convertPoint];
    
    
    float animationDuration = 1000 * (distance / 50.0);
    
    
    
    
    if(followBlueDot){
        long long currentTime = [self getSystemTimeMillis];


        NSNumber * orientation = @(self.controller.userLocation.orientation);
        if(followBlueDotHeading){
            // Mathematically, this seems wrong to me.
//                orientation = @( -1.0 * self.controller.userLocation.orientation);
        }

        if(currentTime - lastFollowBlueDot > followBlueDotInterval.longLongValue){
            [self centerMapOnPosition:@(convertPoint.x) y:@(convertPoint.y) zoom:nil orientation:nil animationDuration:@(animationDuration)];
        }

    }
        
        [self setMapUserPosition:convertPoint orientation:@(angle)];
        
//        [self.controller.userLocation setImage:rotatedArrow];
    
        
        
        
        
//        [eventEmitter sendEvent:@"USER_POSITION_UPDATED" body: newUserLocation];
        
        
//    });
    // CGPoint point = CGPointMake(x.floatValue, y.floatValue);
    // [self setMapgsition:point];
}


-(long long) getSystemTimeMillis {
    NSDate *now = [NSDate date];
    NSTimeInterval timeInterval = [now timeIntervalSinceReferenceDate];
    NSTimeInterval milliseconds = timeInterval * 1000.0;
    long long currentTimeMillis = (long long)milliseconds;
    return currentTimeMillis;
}

//RCT_EXPORT_METHOD(setUserPositionXY:(nonnull NSNumber *) reactTag
//                 x:(nonnull NSNumber *) x
//                 y:(nonnull NSNumber *) y)
//{
//    CGPoint point = CGPointMake(x.floatValue, y.floatValue);
//    [self setMapUserPosition:point];
//};

RCT_EXPORT_METHOD(clearWayfindingPath:(nonnull NSNumber *) reactTag)
{
    dispatch_async(dispatch_get_main_queue(), ^{
        [self.controller clearWayfindingPath];
    });
};

RCT_EXPORT_METHOD(wayfindToWaypoint:(nonnull NSNumber *) reactTag
                  waypointId:(nonnull NSNumber *) waypointId)
{
    NSLog(@"wayfindToWaypoint - Not available yet, testing in progress");
    JMapPoint * userLocation = [[JMapPoint alloc] initWithX:self.controller.userLocation.center.x Y:self.controller.userLocation.center.y Z:[self.controller.currentMap.id floatValue]];
    
    
    JMapWaypoint * startWaypoint = [self.controller getNearestWaypointWithJMapPoint:userLocation];
    JMapWaypoint * destinationWaypoint = [self.controller.currentMap.waypoints getById:waypointId.intValue];
    
    
    
    [self generateWayfindingPath:startWaypoint destinationWaypoint:destinationWaypoint];

};




RCT_EXPORT_METHOD(wayfindBetweenWaypoints:(nonnull NSNumber *) reactTag
                    originId:(nonnull NSNumber *) originId
                    destinationId:(nonnull NSNumber *) destinationId)
    {

        JMapWaypoint * waypoint1 = [self.controller.currentMap.waypoints getById:originId.intValue];
        JMapWaypoint * waypoint2 = [self.controller.currentMap.waypoints getById:originId.intValue];
        

        [self generateWayfindingPath:waypoint1 destinationWaypoint:waypoint2];
};


RCT_EXPORT_METHOD(drawNavigationPath:(nonnull NSNumber *)reactTag
                    pathId:(nonnull NSString *) pathId
                    shouldFocus:(BOOL) shouldFocus
                    style:(NSDictionary *) style)
{
    if(pathId){
        NSArray<JMapPathPerFloor*>* paths = [generatedPaths objectForKey:pathId];
        if(paths){
            dispatch_async(dispatch_get_main_queue(), ^{
                [self.controller clearWayfindingPath];
                [self.controller drawWayfindingPaths:paths];
            });
        }
        else{
            NSLog(@"Cannot Draw Path, No Path has been generated for key.");
        }
    } else{
        NSLog(@"Cannot Draw Paths, pathId is null");
    }
    
    
};

RCT_EXPORT_METHOD(styleUnitsForDestination:(nonnull NSNumber *) reactTag
                    destination:(NSDictionary *) destination
                    style:(NSDictionary *) style)
{
    NSLog(@"styleUnitsForDestination - Not implemented yet");
};

RCT_EXPORT_METHOD(styleShape:(nonnull NSNumber *) reactTag
                  destination:(nonnull NSNumber *) sid
                  style:(NSDictionary *) style)
{
    NSLog(@"styleShape - Not implemented yet");
};

- (void) centerMapOnPosition:(NSNumber *) x y:(NSNumber *) y zoom:(NSNumber *) zoom orientation:(NSNumber *)orientation animationDuration:(NSNumber *) animationDuration {
    
    dispatch_async(dispatch_get_main_queue(), ^{
//        NSValue *centerPoint = [NSValue valueWithCGPoint:CGPointMake(x, y)];
        
        JMapTransform *transform = [[JMapTransform alloc] initWithX:x y:y scale:@5 rotation:orientation atCenter:nil duration:(animationDuration.floatValue / 1000.0)];
        [self.controller setMapTransform:transform];
    });
}


- (void) generateWayfindingPath:(JMapWaypoint *) startWaypoint destinationWaypoint:(JMapWaypoint *) destinationWaypoint{

        // NSLog("Generating wayfinding Path");
        // JMapWaypoint * to = wapoints1.count > 0 ? [wapoints1 firstObject] : nil;
        // JMapWaypoint * from = wapoints2.count > 0 ? [wapoints2 firstObject] : nil;
            
        // // If waypoints exists, pass it to drawPath method below
        // if (to && from) {
        //     // Calculate a wayfinding path
        //     NSArray<JMapPathPerFloor*>* paths = [self.controller wayfindBetweenWaypoint:from andWaypoint:to withAccessibility:100 withObstacle:nil];
    
        //     // Iterate through paths to be drawn
        //     for (JMapPathPerFloor * path in paths) {
        //         // Pass the path to the controller to be drawn
        //         [self.controller drawWayfindingPath:path];
        //     }
        // }

        if (startWaypoint && destinationWaypoint) {
        // Calculate a wayfinding path
        NSArray<JMapPathPerFloor*>* paths = [self.controller wayfindBetweenWaypoint:startWaypoint andWaypoint:destinationWaypoint withAccessibility:100 withObstacle:nil];

        // Iterate through paths to be drawn
//       for (JMapPathPerFloor * path in paths) {
//           // Pass the path to the controller to be drawn
//           [self.controller drawWayfindingPath:path];
//       }

        
        NSString *key = [@"" stringByAppendingFormat:@"%@_%@", [startWaypoint.id stringValue], [destinationWaypoint.id stringValue]];
        
        NSArray <JMapInstruction *>* instructions = [self.navKit createInstructionsFromPaths:paths];
        
        NSArray * processedInstructions = [self processInstructions:instructions];
        
//        [mutableDictionary setObject:paths forKey:key];
        
        NSMutableArray *pathArray = [NSMutableArray array];
        for (JMapPathPerFloor *pathPerFloor in paths){
            NSDictionary *pathPerFloorDict = [JibestreamConverter jMapPathPerFloorToDict:pathPerFloor jMapController:self.controller];
             [pathArray addObject:pathPerFloorDict];
        }
        

        NSDictionary *pathParameters = @{
           @"pathId": key,
           @"instructions": ObjectOrNull(processedInstructions),
           @"start": [JibestreamConverter jMapWaypointToDict:startWaypoint],
           @"end": [JibestreamConverter jMapWaypointToDict:destinationWaypoint],
           @"path": pathArray,
        };
            
        generatedPaths[key] = paths;
        [eventEmitter sendEvent:@"NAVIGATION_PATH_GENERATED" body: pathParameters];
    } 


}



- (void)loadMap{
    _jMap = [[JMap alloc] initWithOptions:options];
    _jMap.delegate = self;
}


- (void)jmapInitialized:(JMapError *)error {
    if (error) {
        NSLog(@"Error: %@", error.message);
        // initializeRejectCallbackId(@"message",error.message, nil);
    } else {
        self.controller = _jMap.controller;
//        [self setupUIKit];
        
        [eventEmitter sendEvent:@"WINDOW_LOADED" body: nil];
        _navKit = [[JMapNavigation alloc] initWithController:self.controller andOptions:@{@"layersOfInterest" : @[@"Units"]}];
        // initializeResolveCallbackId(@"Success");
        [self sendDestinations];
        
        [self.controller updateUserLocation:CGPointMake(self.controller.currentMap.width.floatValue/2.0, self.controller.currentMap.height.floatValue/2.0) floorMap:self.controller.currentMap orientation:@(0) confidenceRadius:@(100)];
        [self.controller.userLocation setImage:arrowIcon];
        
        [self.controller.userLocation snapToWayfindingPathWithThreshold:50];
        [self.controller.userLocation setSpeed:50];
        
    

    }
}

//- (void)animationFinished:(NSNotification *)notification {
//    NSDictionary *data = notification.userInfo;
//    JMapMovingObject *movObj = data[@"MovingObject"];
//    if (movObj == self.arrow) {
////        [self animateBlueDotWithPath];
//    }
//}

-(void) sendDestinations{
    NSLog(@"Sending Destinations");
    NSArray *destinationsAll = [self.controller.activeVenue.destinations getAll];

    NSMutableArray *encodedDestinations = [NSMutableArray array];
    for (JMapDestination *dest in destinationsAll){

        NSDictionary *destinationData = [JibestreamConverter jMapDestinationToDict:dest];
        [encodedDestinations addObject:destinationData];
    }



    [eventEmitter sendEvent:@"GENERATED_SEARCH_DESTINATIONS" body: encodedDestinations];
}

-(void) setMapUserPosition:(CGPoint)point orientation:(NSNumber *) orientation{
    
    dispatch_async(dispatch_get_main_queue(), ^{
        [self.controller updateUserLocation:point floorMap:self.controller.currentMap orientation:orientation confidenceRadius:@100];
        NSArray *newUserLocation = @[@(point.x), @(point.y)];
        [eventEmitter sendEvent:@"USER_POSITION_UPDATED" body: newUserLocation];
        
//        UIImage * newIcon = [self rotateImage:arrowIcon rotation:orientation.floatValue];
//        [self.controller.userLocation setImage:newIcon];
    
        
        
    });
}

static id ObjectOrNull(id object){
    return object ?: [NSNull null];
}

- (void) onReady:(bool)ready
{
    NSDictionary *eventData = @{
        @"ready": @(ready),
    };
    
    NSLog(@"Ready!");
    [eventEmitter sendEvent:@"ODP_READY" body:eventData];
}

- (void) onKeyValidation:(bool)validated
{
    
    if (![self.extend isServiceStarted] && validated)
    {
        NSLog(@"On Key Validation");
        [self.extend setVicinityEnabled:true];
        [self.extend start];
        
    }else{
        NSLog(@"Failed to Validate Key");
    }
    
    NSDictionary *eventData = @{
        @"validated": @(validated),
    };
    
    [eventEmitter sendEvent:@"ODP_KEY_VALIDATION" body:eventData];
}

- (void) onNavigationUpdate:(TDNavOutput *)navOutput{
    NSDictionary *eventData = @{
        @"lat": ObjectOrNull(@(navOutput.latitude)),
        @"long": ObjectOrNull(@(navOutput.longitude)),
        @"bearing": ObjectOrNull(@(navOutput.bearing)),
        @"viewHeading": ObjectOrNull(@(navOutput.viewHeading)),
        @"floor": ObjectOrNull(@(navOutput.floor)),
        @"accuracyRadius": ObjectOrNull(@(navOutput.accuracyRadius)),
        @"utc": ObjectOrNull(@(navOutput.utc)),
        @"x": ObjectOrNull(@(navOutput.x)),
        @"y": ObjectOrNull(@(navOutput.y)),
        @"xFom": ObjectOrNull(@(navOutput.xFom)),
        @"yFom": ObjectOrNull(@(navOutput.yFom)),
        @"usedSystems": ObjectOrNull(@(navOutput.usedSystems)),
        @"dynamicState": ObjectOrNull(@(navOutput.dynamicState)),
        @"elevationState": ObjectOrNull(@(navOutput.elevationState)),
        @"pdrSpeedLimitExceeded": ObjectOrNull(@(navOutput.pdrSpeedLimitExceeded))
    };
    
    CGPoint convertPoint = CGPointMake(navOutput.longitude, navOutput.latitude);
    convertPoint = [JMapUtils convertPoint:convertPoint fromProjection:@"EPSG:4326" toProjection:@"jmap:local" inVenue:self.controller.activeVenue];

    // [self setMapUserPosition:convertPoint];

    [eventEmitter sendEvent:@"ODP_NAVIGATION_UPDATE" body:eventData];
}

- (void) onFacilityUpdateName:(NSString *)name onFacilityUpdateLocation:(Location *)location onFacilityUpdateRegion:(Region *)region onFacilityUpdateFloorPlans:(NSArray *)plans onFacilityUpdateCategories:(NSArray *)categories {
    
    NSDictionary *locationDict = @{
        @"latitude": ObjectOrNull(@(location.latLong.latitude)),
        @"longitude": ObjectOrNull(@(location.latLong.longitude)),
        @"x": ObjectOrNull(@(location.x)),
        @"y": ObjectOrNull(@(location.y)),
        @"z": ObjectOrNull(@(location.z)),
        @"altitude": ObjectOrNull(@(location.altitude)),
        @"isGeo": ObjectOrNull(@(location.isGeo)),
        
    };
    
    
    NSDictionary *regionDict = @{
        @"floor": ObjectOrNull(@(region.floor)),
        @"id": ObjectOrNull(@(region.uid)),
        @"name": ObjectOrNull(region.name),
        @"icon": ObjectOrNull(region.icon),
        @"type": ObjectOrNull(region.type),
        @"points": ObjectOrNull(region.locations),
        @"distanceToUser": ObjectOrNull(@(region.distanceToUser)),
        @"userOnSameFloor": ObjectOrNull(@(region.userOnSameFloor)),
        @"className": ObjectOrNull(region.type),
    };
    
    NSDictionary *eventData = @{
        @"name": name,
        @"location": locationDict,
        @"region": regionDict,
        @"floorPlans": ObjectOrNull(plans),
    };
    
       [eventEmitter sendEvent:@"ODP_FACILITY_UPDATE" body:eventData];
    
}

- (void) dataLoadEvent: (NSString *)data
{
}


- (NSMutableArray *) processInstructions:(NSArray *) instructions{
    NSMutableArray *processedInstructions = [NSMutableArray array];
    
    for (JMapInstruction * instruction in instructions) {
        
        NSMutableDictionary * pInstruction = [NSMutableDictionary dictionary];
        
        
        
        if (instruction.decisionPoint != nil) {
            pInstruction[@"wp"] = instruction.decisionPoint.id;
        } else{
            pInstruction[@"wp"]  = instruction.completionPoint.id;
        }
        
        float distance = instruction.pixelDistance * self.controller.currentMap.mmPerPixel.floatValue / 1000.0;
        pInstruction[@"distance"] = @(distance);
        pInstruction[@"remainingDistance"] = @(distance);
        NSString *units = @" meters";
        
        if(round(distance) ==1){
            units = @" meter";
        }
        
        pInstruction[@"direction"] = instruction.direction;
        
        NSString * prepend = @"";
        
        if([instruction.direction isEqualToString:@"Left"] || [instruction.direction isEqualToString:@"Right"]){
            prepend = @"Turn ";
        }
        pInstruction[@"prepend"] = prepend;
        
        
        if (instruction.surroundingElements &&
            instruction.surroundingElements.shapes &&
            instruction.surroundingElements.shapes.count > 0){
            
            NSArray * dataUnits = instruction.surroundingElements.shapes[0].shape.meta[@"data-unit"];
            
            
            if(dataUnits && dataUnits.count >0){
                NSNumber * destinationId = dataUnits[0];
                
                JMapDestination * dest = [self.controller.activeVenue.destinations getById:destinationId.intValue];
                
                NSString * destinationName = dest.name;
                
                if(destinationName){
                    pInstruction[@"destinationName"] = destinationName;
                    pInstruction[@"dest"] = destinationId;
                    pInstruction[@"fullText"] = [NSString stringWithFormat:@"%@ at %@ in %@ %@", instruction.text, destinationName, [@(distance) stringValue], units];
                }else{
                    pInstruction[@"dest"] = destinationId;
                    pInstruction[@"fullText"] = [NSString stringWithFormat:@"%@ in %@ %@", instruction.text, [@(distance) stringValue], units];
                }
            }else{
                pInstruction[@"destinationName"] = @"";
                pInstruction[@"dest"] = ObjectOrNull(nil);
                pInstruction[@"fullText"] = [NSString stringWithFormat:@"%@ in %@ %@", instruction.text, [@(distance) stringValue], units];
            }
            
            
        }
        
        NSArray *points = @[];//@[@0, @0];
        
        pInstruction[@"startPoint"] = points;
        pInstruction[@"endPoint"] = points;
        
        [processedInstructions addObject:pInstruction];
    }
    
    
    
    return processedInstructions;
}
//
//- (void)setupUIKit {
//    // Initialize UI Kit
//    self.mapUIKit = [[JMapUI alloc] initWithController:self.controller andViewController:self andOptions:nil];
//    self.mapUIKit.delegate = self;
//
//    // Call to show map elements
//    [self loadUIElements];
//}
//
//- (void)loadUIElements {
//
//    // Call to load search bar
//    [self loadSearchBar];
//
//    // Call to load compass
//
//    [self loadCompass];
//}
//
//- (void)loadSearchBar {
//    // Load Search Bar
//    NSDictionary * searchOption = @{@"placeholder": @"Search", @"maxResults": @3, @"position": @0.5};
//    [self.mapUIKit renderSearchWithOptions:searchOption];
//}
//
//- (void)loadCompass {
//    // Load compass
//    NSLog(@"Showing Compass");
//    NSDictionary *compassOption = @{@"resetRotationOnTap": @1, @"position": @[@0.3, @0.3], @"width": @75, @"height": @75};
//    dispatch_async(dispatch_get_main_queue(), ^{
//        [self.mapUIKit renderCompassWithOptions:compassOption];
//    });
//
//}

//- (void)canvas:(nonnull JMapCanvas *)canvas scrollViewDidRotateByDegrees:(float)degrees {
//    [self.mapUIKit updateCompass:degrees];
//}

//- (void)actionButtonCallback:(nonnull Popup *)popup {
//    NSLog(@"Action Button Callback");
//}

- (void)onSelect:(id)item {
    NSLog(@"On Select");
}

- (void)canvas:(nonnull JMapCanvas *)canvas detectedTapOnElement:(nullable id)element atPoint:(CGPoint)point{
    printf("Detected Tap at Location %f, %f\n", point.x, point.y);
    NSDictionary *tapLocation = @{
        @"x": ObjectOrNull(@(point.x)),
        @"y": ObjectOrNull(@(point.y)),
    };
    
    [eventEmitter sendEvent:@"MAP_TAPPED_GENERIC" body: tapLocation];
    
}

//-(UIImage *) rotateImage:(UIImage *) sourceImage rotation:(float) degrees{
//    CGSize size = sourceImage.size;
//    CGFloat radians = degrees / 180.0 * M_PI;
//
//    UIView *rotatedViewBox = [[UIView alloc] initWithFrame:CGRectMake(0,0, sourceImage.size.width, sourceImage.size.height)];
//    CGAffineTransform t = CGAffineTransformMakeRotation(radians);
//    rotatedViewBox.transform = t;
//    CGSize rotatedSize = rotatedViewBox.frame.size;
//
//    UIGraphicsBeginImageContextWithOptions(rotatedSize, NO, [[UIScreen mainScreen] scale]);
//    CGContextRef bitmap = UIGraphicsGetCurrentContext();
//
//    CGContextTranslateCTM(bitmap, rotatedSize.width / 2, rotatedSize.height / 2);
//
//    CGContextRotateCTM(bitmap, radians);
//
//    CGContextScaleCTM(bitmap, 1.0, -1.0);
//    CGContextDrawImage(bitmap, CGRectMake(-sourceImage.size.width / 2, -sourceImage.size.height / 2 , sourceImage.size.width, sourceImage.size.height), sourceImage.CGImage );
//
//    UIImage *newImage = UIGraphicsGetImageFromCurrentImageContext();
//    UIGraphicsEndImageContext();
//
//    return newImage;
//}

- (float) getAngleBetweenPoints:(CGPoint) startPoint endPoint:(CGPoint) endPoint{
    
    float theta = atan2(endPoint.y - startPoint.y, endPoint.x - startPoint.x) + M_PI / 2.0;
    
    double angle = theta / M_PI * 180;
    
    if (angle < 0){
        angle +=360;
    }
    return angle;

}

- (float) getDistanceBetweenPoints:(CGPoint) startPoint endPoint:(CGPoint) endPoint{
    
    return sqrtf(pow(startPoint.x - endPoint.x,2) + pow(startPoint.y - endPoint.y,2));
}

    

@end






