"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _MapViewManager = require("./MapViewManager");
var _SendCommand = require("./SendCommand");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const MapView = (props, parentRef) => {
  const nodeRef = (0, _react.useRef)(null);
  const [onNavigationPathGeneratedValue, setOnNavigationPathGeneratedValue] = (0, _react.useState)(null);
  const [onDestinationSelectedValue, setOnDestinationSelectedValue] = (0, _react.useState)(null);
  const [onUserPositionUpdatedValue, setOnUserPositionUpdatedValue] = (0, _react.useState)(null);
  const [onSearchDestinationsGeneratedValue, setOnSearchDestinationsGeneratedValue] = (0, _react.useState)(null);
  const [onMapTappedGenericValue, setOnMapTappedGenericValue] = (0, _react.useState)(null);
  (0, _react.useEffect)(() => {
    if (_reactNative.Platform.OS == 'android') {
      (0, _SendCommand.createFragment)((0, _reactNative.findNodeHandle)(nodeRef.current));
    }
  }, []);
  (0, _react.useEffect)(() => {
    var _props$onMapMessage$o, _props$onMapMessage;
    if (onDestinationSelectedValue != null) (_props$onMapMessage$o = (_props$onMapMessage = props.onMapMessage).onDestinationSelected) === null || _props$onMapMessage$o === void 0 ? void 0 : _props$onMapMessage$o.call(_props$onMapMessage, onDestinationSelectedValue);
  }, [onDestinationSelectedValue]);
  (0, _react.useEffect)(() => {
    if (onNavigationPathGeneratedValue != null) {
      var _props$onMapMessage$o2, _props$onMapMessage2;
      let pathId, instructions, start, end, path;
      ({
        pathId,
        instructions,
        start,
        end,
        path
      } = onNavigationPathGeneratedValue);
      (_props$onMapMessage$o2 = (_props$onMapMessage2 = props.onMapMessage).onNavigationPathGenerated) === null || _props$onMapMessage$o2 === void 0 ? void 0 : _props$onMapMessage$o2.call(_props$onMapMessage2, pathId, instructions, start, end, path);
    }
  }, [onNavigationPathGeneratedValue]);
  (0, _react.useEffect)(() => {
    var _props$onMapMessage$o3, _props$onMapMessage3;
    if (onUserPositionUpdatedValue != null) (_props$onMapMessage$o3 = (_props$onMapMessage3 = props.onMapMessage).onUserPositionUpdated) === null || _props$onMapMessage$o3 === void 0 ? void 0 : _props$onMapMessage$o3.call(_props$onMapMessage3, onUserPositionUpdatedValue);
  }, [onUserPositionUpdatedValue]);
  (0, _react.useEffect)(() => {
    var _props$onMapMessage$o4, _props$onMapMessage4;
    if (onSearchDestinationsGeneratedValue != null) (_props$onMapMessage$o4 = (_props$onMapMessage4 = props.onMapMessage).onSearchDestinationsGenerated) === null || _props$onMapMessage$o4 === void 0 ? void 0 : _props$onMapMessage$o4.call(_props$onMapMessage4, onSearchDestinationsGeneratedValue);
  }, [onSearchDestinationsGeneratedValue]);
  (0, _react.useEffect)(() => {
    var _props$onMapMessage$o5, _props$onMapMessage5;
    if (onMapTappedGenericValue != null) (_props$onMapMessage$o5 = (_props$onMapMessage5 = props.onMapMessage).onMapTappedGeneric) === null || _props$onMapMessage$o5 === void 0 ? void 0 : _props$onMapMessage$o5.call(_props$onMapMessage5, onMapTappedGenericValue);
  }, [onMapTappedGenericValue]);
  (0, _react.useImperativeHandle)(parentRef, () => {
    const viewId = (0, _reactNative.findNodeHandle)(nodeRef.current);
    const listeners = {
      setMapVenue: credentials => {
        //, mapOptions: MAP_OPTIONS
        setTimeout(function () {
          (0, _SendCommand.setMapVenue)({
            viewId,
            credentials
          });
        }, 500);
      },
      // setMapVenue: ({
      //   credentials,
      //   compass,
      //   floorSelector,
      //   zoomButtons,
      //   search,
      // }: {
      //   credentials: MAP_CREDENTIALS;
      //   compass?: MAP_COMPASS_PROPERTIES;
      //   floorSelector?: MAP_FLOOR_SELECTOR_PROPERTIES;
      //   zoomButtons?: MAP_ZOOM_BUTTON_PROPERTIES;
      //   search?: MAP_SEARCH_PROPERTIES;
      // }) => {
      //   setMapVenue({
      //     viewId,
      //     credentials,
      //     compass,
      //     floorSelector,
      //     zoomButtons,
      //     search,
      //   });
      // },
      centerMapOnUser: function (orientation) {
        let zoom = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 5;
        let animationDuration = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1000;
        (0, _SendCommand.centerMap)(viewId, orientation, zoom, animationDuration);
      },
      setFollowBlueDot: function (enabled) {
        let rotate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
        let interval = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 500;
        (0, _SendCommand.setFollowBlueDot)(viewId, enabled, rotate, interval);
      },
      setUserPosition: (lat, long, heading, confidence) => {
        (0, _SendCommand.setUserPosition)(viewId, lat, long, heading, confidence, null);
      },
      setUserPositionXY: (x, y, heading, confidence) => {
        (0, _SendCommand.setUserPosition)(viewId, x, y, heading, confidence, 'xy');
      },
      clearWayfindingPath: () => {
        (0, _SendCommand.clearWayfindingPath)(viewId);
      },
      wayfindToWaypoint: waypointId => {
        (0, _SendCommand.wayfindToWaypoint)(viewId, waypointId);
      },
      wayfindBetweenWaypoints: (originId, destinationId) => {
        (0, _SendCommand.wayfindBetweenWaypoints)(viewId, originId, destinationId);
      },
      drawNavigationPath: function (pathId) {
        let shouldFocus = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
        let style = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {
          stroke: '#ffc956',
          strokeWidth: 3
        };
        (0, _SendCommand.drawNavigationPath)(viewId, pathId, shouldFocus, style);
      }
      //   styleUnitsForDestination: (
      //     destination: JIBESTREAM_DESTINATION,
      //     style: JIBESTREAM_STYLE = { fill: '#ABABAB' }
      //   ) => {
      //     styleUnitsForDestination(viewId, destination, style);
      //   },
      //   styleShape: (
      //     unitId: number,
      //     style: JIBESTREAM_STYLE = { fill: '#ABABAB' }
      //   ) => {
      //     styleShape(viewId, unitId, style);
      //   },
    };

    return listeners;
  });
  (0, _react.useEffect)(() => {
    var _eventEmitter, _eventEmitter2, _eventEmitter3, _eventEmitter4, _eventEmitter5;
    console.log('Initializing Event Emitter');
    let eventEmitter = null;
    if (_reactNative.Platform.OS == 'android') {
      eventEmitter = _reactNative.DeviceEventEmitter;
    } else if (_reactNative.Platform.OS == 'ios') {
      console.log(_MapViewManager.CTPEventEmitter);
      eventEmitter = new _reactNative.NativeEventEmitter(_MapViewManager.CTPEventEmitter);
    }
    (_eventEmitter = eventEmitter) === null || _eventEmitter === void 0 ? void 0 : _eventEmitter.addListener('DESTINATION_SELECTED', data => setOnDestinationSelectedValue(data)
    // props.onMapMessage.onDestinationSelected?.(data)
    );

    (_eventEmitter2 = eventEmitter) === null || _eventEmitter2 === void 0 ? void 0 : _eventEmitter2.addListener('NAVIGATION_PATH_GENERATED', data => setOnNavigationPathGeneratedValue(data)
    // props.onMapMessage.onNavigationPathGenerated?.(
    //   data.pathId,
    //   data.instructions,
    //   data.start,
    //   data.end,
    //   data.path
    // )
    );

    (_eventEmitter3 = eventEmitter) === null || _eventEmitter3 === void 0 ? void 0 : _eventEmitter3.addListener('USER_POSITION_UPDATED', userPosition => setOnUserPositionUpdatedValue(userPosition)
    // props.onMapMessage.onUserPositionUpdated?.(userPosition)
    );

    (_eventEmitter4 = eventEmitter) === null || _eventEmitter4 === void 0 ? void 0 : _eventEmitter4.addListener('GENERATED_SEARCH_DESTINATIONS', destinations => setOnSearchDestinationsGeneratedValue(destinations)
    // props.onMapMessage.onSearchDestinationsGenerated?.(destinations)
    );

    // eventEmitter?.addListener('WINDOW_LOADED', () =>
    //   props.onMapMessage.onWindowLoaded?.()
    // );
    (_eventEmitter5 = eventEmitter) === null || _eventEmitter5 === void 0 ? void 0 : _eventEmitter5.addListener('MAP_TAPPED_GENERIC', event => setOnMapTappedGenericValue(event)
    // props.onMapMessage.onMapTappedGeneric?.(data)
    );
    // eventEmitter?.addListener('ODP_READY', (event: ODP_ON_READY) => {
    //   console.log('ODP onReady');
    //   props.onOdpEvent.onReady?.(event);
    // });
    // eventEmitter?.addListener(
    //   'ODP_KEY_VALIDATION',
    //   (event: ODP_ON_KEY_VALIDATION) => {
    //     console.log('ODP onKeyValidation');
    //     props.onOdpEvent.onKeyValidation?.(event);
    //   }
    // );
    // eventEmitter?.addListener(
    //   'ODP_NAVIGATION_UPDATE',
    //   (event: ODP_ON_NAVIGATION_UPDATE) => {
    //     props.onOdpEvent.onNavigationUpdate?.(event);
    //   }
    // );
    // eventEmitter?.addListener(
    //   'ODP_FACILITY_UPDATE',
    //   (event: ODP_ON_FACILITY_UPDATE) => {
    //     console.log('ODP onFacilityUpdate');
    //     props.onOdpEvent.onFacilityUpdate?.(event);
    //   }
    // );
    return () => {
      var _eventEmitter6, _eventEmitter7, _eventEmitter8;
      console.log('Removing Event Emitters');
      (_eventEmitter6 = eventEmitter) === null || _eventEmitter6 === void 0 ? void 0 : _eventEmitter6.removeAllListeners('DESTINATION_SELECTED');
      (_eventEmitter7 = eventEmitter) === null || _eventEmitter7 === void 0 ? void 0 : _eventEmitter7.removeAllListeners('NAVIGATION_PATH_GENERATED');
      (_eventEmitter8 = eventEmitter) === null || _eventEmitter8 === void 0 ? void 0 : _eventEmitter8.removeAllListeners('USER_POSITION_UPDATED');
      //   eventEmitter?.removeAllListeners('WINDOW_LOADED');
      //   eventEmitter?.removeAllListeners('MAP_TAPPED_GENERIC');
      //   eventEmitter?.removeAllListeners('ODP_READY');
      //   eventEmitter?.removeAllListeners('ODP_KEY_VALIDATION');
      //   eventEmitter?.removeAllListeners('ODP_NAVIGATION_UPDATE');
      //   eventEmitter?.removeAllListeners('ODP_FACILITY_UPDATE');
    };
  }, []);
  return /*#__PURE__*/_react.default.createElement(_reactNative.SafeAreaView, {
    style: {
      flex: 1,
      width: '100%',
      height: '100%'
    }
  }, _MapViewManager.MapViewManager ? /*#__PURE__*/_react.default.createElement(_MapViewManager.MapViewManager, {
    style: _reactNative.Platform.OS == 'android' ? {
      // converts dpi to px, provide desired height
      height: _reactNative.PixelRatio.getPixelSizeForLayoutSize(props.style.height),
      // converts dpi to px, provide desired width
      width: _reactNative.PixelRatio.getPixelSizeForLayoutSize(props.style.width)
    } : {
      height: props.style.height / 1,
      width: props.style.width / 1
      // converts dpi to px, provide desired height
      // height: PixelRatio.getPixelSizeForLayoutSize(props.style.height),
      // converts dpi to px, provide desired width
      // width: PixelRatio.getPixelSizeForLayoutSize(props.style.width),
    },

    ref: nodeRef
  }) : null);
};
const mapViewFwRef = /*#__PURE__*/(0, _react.forwardRef)(MapView);
// mapViewFwRef.propTypes = {
//   eventEmitter: PropTypes.
// }
var _default = mapViewFwRef;
exports.default = _default;
//# sourceMappingURL=MapView.js.map