export let EventType = /*#__PURE__*/function (EventType) {
  EventType["REFETCH_COMMENT"] = "refetchComment";
  return EventType;
}({});

/**
 * Event emitter to subscribe, dispatch, and unsubscribe to events.
 */
export const eventEmitter = {
  //This is event object to store events.
  events: {},
  //Internal function to get event name from type and suffix
  getEventKey(eventType, uniqueSuffix) {
    return `${eventType} ${uniqueSuffix}`;
  },
  //This will dispatch the event and call the callback for every event.
  dispatch(event, uniqueSuffix) {
    var _this$events$eventNam;
    const eventName = this.getEventKey(event, uniqueSuffix);
    if (!this.events[eventName]) return;
    (_this$events$eventNam = this.events[eventName]) === null || _this$events$eventNam === void 0 ? void 0 : _this$events$eventNam.forEach(callback => callback());
  },
  //This will subscribe the event with a specific callback
  subscribe(event, uniqueSuffix, callback) {
    var _this$events$eventNam2, _this$events$eventNam3, _this$events$eventNam4;
    const eventName = this.getEventKey(event, uniqueSuffix);
    if (!this.events[eventName]) this.events[eventName] = [];
    if (!((_this$events$eventNam2 = this.events[eventName]) !== null && _this$events$eventNam2 !== void 0 && _this$events$eventNam2.includes((_this$events$eventNam3 = this.events[eventName]) === null || _this$events$eventNam3 === void 0 ? void 0 : _this$events$eventNam3[0]))) (_this$events$eventNam4 = this.events[eventName]) === null || _this$events$eventNam4 === void 0 ? void 0 : _this$events$eventNam4.push(callback);
  },
  //This will unsubscribe the event to avoid unnecessary event calls
  unsubscribe(event, uniqueSuffix) {
    const eventName = this.getEventKey(event, uniqueSuffix);
    if (!this.events[eventName]) return;
    delete this.events[eventName];
  }
};
//# sourceMappingURL=MapEventEmitter.js.map