/// <reference types="react" />
import { getCurrentInstruction } from './Instructions';
import { COMMANDS_FROM_MAP, COMMANDS_TO_MAP, EVENTS_FROM_ODP, MAP_EVENT_LISTENER, MAP_VIEW_REFERENCE, ODP_EVENT_LISTENER, ODP_VIEW_REFERENCE } from './CommandTypes';
import { JIBESTREAM_DESTINATION, JIBESTREAM_WAYPOINT, JIBESTREAM_PATH, JIBESTREAM_LOCATION, JIBESTREAM_STYLE, INSTRUCTION, MAP_CREDENTIALS, MAP_TAP_EVENT } from './JibestreamTypes';
import { ODP_ON_FACILITY_UPDATE } from './schemas/OdpOnFacilityUpdateType';
import { ODP_ON_KEY_VALIDATION } from './schemas/OdpOnKeyValidationType';
import { ODP_ON_NAVIGATION_UPDATE } from './schemas/OdpOnNavigationUpdateType';
import { ODP_ON_READY } from './schemas/OdpOnReadyType';
export declare const JMapView: import("react").ForwardRefExoticComponent<{
    style: {
        height: number;
        width: number;
    };
    onMapMessage: MAP_EVENT_LISTENER;
    onOdpEvent: ODP_EVENT_LISTENER;
} & import("react").RefAttributes<unknown>>;
export declare const Utilities: {
    getCurrentInstruction: typeof getCurrentInstruction;
    preProcessPath: (path: JIBESTREAM_PATH[], instructions: INSTRUCTION[]) => INSTRUCTION[];
};
export type COMMANDS_TO_MAP_TYPE = COMMANDS_TO_MAP;
export type COMMANDS_FROM_MAP_TYPE = COMMANDS_FROM_MAP;
export type EVENTS_FROM_ODP_TYPE = EVENTS_FROM_ODP;
export type MAP_EVENT_LISTENER_TYPE = MAP_EVENT_LISTENER;
export type ODP_EVENT_LISTENER_TYPE = ODP_EVENT_LISTENER;
export type MAP_VIEW_REFERENCE_TYPE = MAP_VIEW_REFERENCE;
export type ODP_VIEW_REFERENCE_TYPE = ODP_VIEW_REFERENCE;
export type JIBESTREAM_DESTINATION_TYPE = JIBESTREAM_DESTINATION;
export type JIBESTREAM_WAYPOINT_TYPE = JIBESTREAM_WAYPOINT;
export type JIBESTREAM_PATH_TYPE = JIBESTREAM_PATH;
export type JIBESTREAM_LOCATION_TYPE = JIBESTREAM_LOCATION;
export type JIBESTREAM_STYLE_TYPE = JIBESTREAM_STYLE;
export type INSTRUCTION_TYPE = INSTRUCTION;
export type MAP_TAP_EVENT_TYPE = MAP_TAP_EVENT;
export type MAP_CREDENTIALS_TYPE = MAP_CREDENTIALS;
export type ODP_ON_FACILITY_UPDATE_TYPE = ODP_ON_FACILITY_UPDATE;
export type ODP_ON_KEY_VALIDATION_TYPE = ODP_ON_KEY_VALIDATION;
export type ODP_ON_NAVIGATION_UPDATE_TYPE = ODP_ON_NAVIGATION_UPDATE;
export type ODP_ON_READY_TYPE = ODP_ON_READY;
//# sourceMappingURL=index.d.ts.map